diff -bruN freeswan-1.9.orig/pluto/kernel.c freeswan-1.9/pluto/kernel.c
--- freeswan-1.9.orig/pluto/kernel.c	Mon Jan 29 01:20:43 2001
+++ freeswan-1.9/pluto/kernel.c	Thu Jun  7 12:02:17 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: kernel.c,v 1.105 2001/01/29 06:20:43 dhr Exp $
+ * RCSID $Id: kernel.c,v 1.121 2001/06/02 19:34:22 dhr Exp $
  */
 
 #include <stddef.h>
@@ -44,11 +44,13 @@
 #include "id.h"
 #include "connections.h"	/* needs id.h */
 #include "state.h"
+#include "timer.h"
 #include "kernel.h"
 #include "log.h"
 #include "server.h"
 #include "whack.h"	/* for RC_LOG_SERIOUS */
 
+extern int send_delete(struct state *st, ipsec_spi_t *spi, bool ESP);
 
 bool can_do_IPcomp = TRUE;  /* can system actually perform IPCOMP? */
 
@@ -57,7 +59,80 @@
  */
 #define REPLAY_WINDOW	64
 
-#ifdef KLIPS
+static bool route_and_eroute(struct connection *c
+    , struct state *st);       /* forward declaration */
+
+/* test if the routes required for two different connections agree
+ * It is assumed that the destination subnets agree; we are only
+ * testing that the interfaces and nexthops match.
+ */
+#define routes_agree(c, d) ((c)->interface == (d)->interface \
+         && sameaddr(&(c)->this.host_nexthop, &(d)->this.host_nexthop))
+
+#ifndef KLIPS
+
+bool no_klips = TRUE;  /* don't actually use KLIPS */
+
+#else /* !KLIPS */
+
+/* declare eroute things early enough for uses */
+
+#define ERO_REPLACE_FLAG   0x100       /* out of band */
+#define ERO_DELETE     SADB_X_DELFLOW
+#define ERO_ADD        SADB_X_ADDFLOW
+#define ERO_REPLACE    (SADB_X_ADDFLOW | ERO_REPLACE_FLAG)
+
+/* bare (connectionless) shunt (eroute) table
+ *
+ * Bare shunts are those that don't "belong" to a connection.
+ * This happens because some TRAPped traffic hasn't yet or cannot be
+ * assigned to a connection.  The usual reason is that we cannot discover
+ * the peer SG.  Another is that even when the peer has been discovered,
+ * it may be that no connection matches all the particulars.
+ * Bare shunts are either HOLD or PASS.
+ * We record them so that, with scanning, we can discover
+ * which HOLDs are news and which PASSes should expire.
+ */
+
+#define SHUNT_SCAN_INTERVAL    (60 * 2)   /* time between scans of eroutes */
+
+/* SHUNT_PATIENCE only has resolution down to a multiple of the sample rate,
+ * SHUNT_SCAN_INTERVAL.
+ * By making SHUNT_PATIENCE an odd multiple of half of SHUNT_SCAN_INTERVAL,
+ * we minimize the effects of jitter.
+ */
+#define SHUNT_PATIENCE (SHUNT_SCAN_INTERVAL * 15 / 2)  /* inactivity timeout */
+struct bare_shunt {
+    ip_subnet ours;
+    ip_subnet his;
+    ip_said said;
+    unsigned long count;
+    time_t last_activity;
+    struct bare_shunt *next;
+};
+
+static struct bare_shunt *bare_shunts = NULL;
+
+/* information from /proc/net/ipsec_eroute */
+
+struct eroute_info {
+    unsigned long count;
+    ip_subnet ours;
+    ip_subnet his;
+    ip_address dst;
+    ip_said    said;
+    struct eroute_info *next;
+};
+
+/* The orphaned_holds table records HOLDs for which we
+ * scan_proc_shunts found no representation of in any connection.
+ * The corresponding ACQUIRE message might have been lost.
+ */
+struct eroute_info *orphaned_holds = NULL;
+
+
+static bool shunt_eroute(struct connection *c
+    , unsigned int op, const char *opname);    /* forward declaration */
 
 bool no_klips = FALSE;	/* don't actually use KLIPS */
 
@@ -184,22 +259,12 @@
 static pfkey_item *pfkey_iq_head = NULL;	/* oldest */
 static pfkey_item *pfkey_iq_tail;	/* youngest */
 
-/* get a PF_KEY message from kernel.
- * Returns TRUE is message found, FALSE if no message pending,
- * and aborts or keeps trying when an error is encountered.
- * The only validation of the message is that the message length
- * received matches that in the message header, and that the message
- * is for this process.
- */
 static bool
-pfkey_get(pfkey_buf *buf)
+pfkey_input_ready(void)
 {
-    for (;;)
-    {
 	fd_set readfds;
 	int ndes;
 	struct timeval tm;
-	ssize_t len;
 
 	tm.tv_sec = 0;	/* don't wait at all */
 	tm.tv_usec = 0;
@@ -216,6 +281,25 @@
 	    return FALSE;	/* nothing to read */
 
 	passert(ndes == 1 && FD_ISSET(pfkeyfd, &readfds));
+    return TRUE;
+}
+
+/* get a PF_KEY message from kernel.
+ * Returns TRUE is message found, FALSE if no message pending,
+ * and aborts or keeps trying when an error is encountered.
+ * The only validation of the message is that the message length
+ * received matches that in the message header, and that the message
+ * is for this process.
+ */
+static bool
+pfkey_get(pfkey_buf *buf)
+{
+    for (;;)
+    {
+	ssize_t len;
+
+        if (!pfkey_input_ready())
+           return FALSE;
 
 	len = read(pfkeyfd, buf->bytes, sizeof(buf->bytes));
 
@@ -345,6 +429,59 @@
     }
 }
 
+static void
+record_and_initiate_opportunistic(ip_subnet *ours, ip_subnet *his)
+{
+    passert(samesubnettype(ours, his));
+
+    /* Add to bare shunt list.
+     * We need to do this because the shunt was installed by KLIPS
+     * which can't do this itself.
+     */
+    {
+       struct bare_shunt *bs = alloc_thing(struct bare_shunt, "bare shunt");
+
+       bs->ours = *ours;
+       bs->his = *his;
+
+       bs->said.proto = SA_INT;
+       bs->said.spi = htonl(SPI_HOLD);
+       bs->said.dst = *aftoinfo(subnettypeof(ours))->any;
+
+       bs->count = 0;
+       bs->last_activity = now();
+
+       bs->next = bare_shunts;
+       bare_shunts = bs;
+    }
+
+    /* actually initiate opportunism */
+    {
+       ip_address src, dst;
+
+       networkof(ours, &src);
+       networkof(his, &dst);
+       initiate_opportunistic(&src, &dst, TRUE, NULL_FD);
+    }
+
+    /* if present, remove from orphaned_holds list.
+     * NOTE: we do this last in case ours or his is a pointer into a member.
+     */
+    {
+       struct eroute_info **pp, *p;
+
+       for (pp = &orphaned_holds; (p = *pp) != NULL; pp = &p->next)
+       {
+           if (samesubnet(ours, &p->ours) && samesubnet(his, &p->his))
+           {
+               *pp = p->next;
+               pfree(p);
+               break;
+           }
+       }
+    }
+}
+
 /* Processs a SADB_ACQUIRE message from KLIPS.
  * Try to build an opportunistic connection!
  * See RFC 2367 "PF_KEY Key Management API, Version 2" 3.1.6
@@ -365,9 +502,10 @@
 static void
 process_pfkey_acquire(pfkey_buf *buf, struct sadb_ext *extensions[SADB_EXT_MAX + 1])
 {
-    ip_address src, dst;
     struct sadb_address *srcx = (void *) extensions[SADB_EXT_ADDRESS_SRC];
     struct sadb_address *dstx = (void *) extensions[SADB_EXT_ADDRESS_DST];
+    ip_address src, dst;
+    ip_subnet ours, his;
     err_t ugh;
 
     if (buf->msg.sadb_msg_pid != 0)
@@ -383,7 +521,15 @@
     ugh = sockaddr_to_ip_address((struct sockaddr *)(void *)&dstx[1], &dst);
     passert(ugh == NULL);
 
-    initiate_opportunistic(&src, &dst, NULL_FD);
+    passert(addrtypeof(&src) == addrtypeof(&dst));
+
+    ugh = rangetosubnet(&src, &src, &ours);
+    passert(ugh == NULL);
+
+    ugh = rangetosubnet(&dst, &dst, &his);
+    passert(ugh == NULL);
+
+    record_and_initiate_opportunistic(&ours, &his);
 }
 
 /* Handle PF_KEY messages from the kernel that are not dealt with
@@ -444,6 +590,17 @@
 	pfkey_iq_head = it->next;
 	pfree(it);
     }
+
+    /* Handle any orphaned holds, but only if no pfkey input is pending.
+     * For each, we initiate Opportunistic.
+     * note: we don't need to advance the pointer because
+     * record_and_initiate_opportunistic will remove the current
+     * record each time we call it.
+     */
+    while (orphaned_holds != NULL && !pfkey_input_ready())
+       record_and_initiate_opportunistic(&orphaned_holds->ours
+           , &orphaned_holds->his);
+
 }
 
 /* asynchronous messages directly from PF_KEY socket */
@@ -597,6 +754,7 @@
 
     /* form the command string */
     {
+	const ip_subnet *epc = EffectivePeerClient(c);
 	char
 	    nexthop_str[ADDRTOT_BUF],
 	    me_str[ADDRTOT_BUF],
@@ -619,10 +777,10 @@
 	addrtot(&ta, 0, myclientmask_str, sizeof(myclientmask_str));
 
 	addrtot(&c->that.host_addr, 0, peer_str, sizeof(peer_str));
-	subnettot(&c->that.client, 0, peerclient_str, sizeof(peerclientnet_str));
-	networkof(&c->that.client, &ta);
+        subnettot(epc, 0, peerclient_str, sizeof(peerclientnet_str));
+        networkof(epc, &ta);
 	addrtot(&ta, 0, peerclientnet_str, sizeof(peerclientnet_str));
-	maskof(&c->that.client, &ta);
+	maskof(epc, &ta);
 	addrtot(&ta, 0, peerclientmask_str, sizeof(peerclientmask_str));
 
 	if (-1 == snprintf(cmd, sizeof(cmd),
@@ -742,114 +900,85 @@
     return TRUE;
 }
 
-bool
-route_connection(struct connection *c, bool doit)
+/* Check that we can route (and eroute).  Diagnose if we cannot. */
+
+static bool
+could_route(struct connection *c)
 {
-    if (c->routed)
-    {
-	/* already done */
-    }
-    else if (HasWildcardIP(*c) && HasWildcardClient(c))
-    {
-	loglog(RC_ROUTE, "cannot route uninstantiated opportunistic connection");
-    }
-    else if (isanyaddr(&c->this.host_nexthop))
+     struct connection *ero     /* who, if anyone, owns our eroute? */
+        , *ro = route_owner(c, &ero);   /* who owns our route? */
+ 
+     /* if we don't know nexthop, we cannot route */
+     if (isanyaddr(&c->this.host_nexthop))
     {
 	loglog(RC_ROUTE, "cannot route connection without knowing nexthop");
+        return FALSE;
     }
-    else if (!no_klips
+
+    /* if routing would affect IKE messages, reject */
+    if (!no_klips
     && c->this.host_port != IKE_UDP_PORT
-    && addrinsubnet(&c->that.host_addr, &c->that.client))
+    && addrinsubnet(&c->that.host_addr, EffectivePeerClient(c)))
     {
 	loglog(RC_LOG_SERIOUS, "cannot install route: peer is within its client");
+	return FALSE;
     }
-    else if (!doit)
-    {
-	/* just testing -- we expect to be able to do it */
-	return TRUE;
-    }
-    else
-    {
-	struct connection *d = route_owner(c, FALSE);
 
-	passert(c->eroute_owner == SOS_NOBODY);
-	if (d == NULL)
-	{
-	    /* nobody's got it: we can try to install our route */
-	    (void) do_command(c, "prepare");	/* just in case; ignore failure */
-	    if (do_command(c, "route"))
-		c->routed = TRUE;
-	}
-	else if (sameaddr(&d->this.host_nexthop, &c->this.host_nexthop)
-	&& d->interface == c->interface)
-	{
-	    /* The other connection has the same nexthop and interface,
-	     * so we're done.
+    /* If there is already a route for peer's client subnet
+     * and it disagrees about interface or nexthop, we cannot steal it.
+     * Note: if this connection is already routed (perhaps for another
+     * state object), the route will agree.
+     * This is as it should be -- it will arise during rekeying.
 	     */
-	    c->routed = TRUE;
-	}
-	else if (d->eroute_owner == SOS_NOBODY)
+    if (ro != NULL && !routes_agree(ro, c))
 	{
-	    /* The other connection has the route, and it conflicts
-	     * (the nexthop or interface differs), but that connection
-	     * isn't using the route.  We'll steal it!  There might be
-	     * other connections using the same route, but none of
-	     * them is using it either (otherwise route_owner()
-	     * would have returned one that did).
-	     *
-	     * A feature of LINUX allows us to install the new route
-	     * before deleting the old if the nexthops differ.
-	     * This reduces the "window of vulnerability" when packets
-	     * might flow in the clear.
-	     *
-	     * c->routed must be set last so that route_owner()
-	     * doesn't find it.
-	     */
-
-	    bool preadd = !sameaddr(&d->this.host_nexthop, &c->this.host_nexthop);
-
-	    if (!preadd || do_command(c, "route"))
-	    {
-		/* one unroute for all */
-		if (do_command(d, "unroute"))
-		{
-		    do {
-			passert(d->eroute_owner == SOS_NOBODY);
-			d->routed = FALSE;
-			d = route_owner(c, FALSE);
-		    } while (d != NULL);
-
-		    if (preadd || do_command(c, "route"))
-			c->routed = TRUE;
-		}
-	    }
+       loglog(RC_LOG_SERIOUS, "cannot route -- route already in use for \"%s\""
+           , ro->name);
+       return FALSE;   /* another connection already using the eroute */
 	}
-	else
+#ifdef KLIPS
+    /* if there is an eroute for another connection, there is a problem */
+    if (ero != NULL && ero != c)
 	{
-	    loglog(RC_LOG_SERIOUS, "cannot install route: connection \"%s\" already has it"
-		, d->name);
-	}
+       loglog(RC_LOG_SERIOUS, "cannot install eroute -- it is in use for \"%s\""
+           , ero->name);
+       return FALSE;   /* another connection already using the eroute */
     }
-    return c->routed;
+#endif /* KLIPS */
+    return TRUE;
 }
 
+bool
+trap_connection(struct connection *c)
+{
+    return could_route(c) && route_and_eroute(c, NULL);
+}
+
+/* delete any eroute for a connection and unroute it if route isn't shared */
 void
 unroute_connection(struct connection *c)
 {
-    /* only unroute if no other connection shares it */
-    if (c->routed)
+    enum routing_t cr = c->routing;
+
+    if (erouted(cr))
     {
-	c->routed = FALSE;
-	if (route_owner(c, FALSE) == NULL && !do_command(c, "unroute"))
-	    c->routed = TRUE;	/* undo on failure */
+       passert(cr != RT_ROUTED_TUNNEL);        /* cannot handle a live one */
+       shunt_eroute(c, ERO_DELETE, "delete");
     }
+
+    c->routing = RT_UNROUTED;  /* do now so route_owner won't find us */
+
+    /* only unroute if no other connection shares it */
+    if (routed(cr)
+    && route_owner(c, NULL) == NULL)
+       (void) do_command(c, "unroute");
 }
 
 
 #ifdef KLIPS
 
 static void
-set_text_said(char *text_said, ip_address *dst, ipsec_spi_t spi, int proto)
+set_text_said(char *text_said, const ip_address *dst, ipsec_spi_t spi, int proto)
 {
     ip_said said;
 
@@ -893,13 +1022,19 @@
 /* pfkey_build + pfkey_address_build */
 static bool
 pfkeyext_address(u_int16_t exttype
-, ip_address *address
+, const ip_address *address
 , const char *description
 , const char *text_said
 , struct sadb_ext *extensions[SADB_EXT_MAX + 1])
 {
+    /* the following variable is only needed to silence
+     * a warning caused by the fact that the argument
+     * to sockaddrof is NOT pointer to const!
+     */
+    ip_address t = *address;
+
     return pfkey_build(pfkey_address_build(extensions + exttype
-	    , exttype, 0, 0, sockaddrof(address))
+           , exttype, 0, 0, sockaddrof(&t))
 	, description, text_said, extensions);
 }
 
@@ -941,8 +1076,17 @@
 
 	    if (r != (ssize_t)len)
 	    {
+               if (r < 0)
+               {
 		log_errno((e, "pfkey write() of %s %s failed"
 		    , description, text_said));
+               }
+               else
+               {
+                   loglog(RC_LOG_SERIOUS, "ERROR: pfkey write() of %s %s truncated: %ld instead of %ld"
+                       , description, text_said
+                       , (long)r, (long)len);
+               }
 		success = FALSE;
 	    }
 	    else
@@ -956,24 +1100,11 @@
 
 		if (!pfkey_get_response(bp, ((struct sadb_msg *) extensions[0])->sadb_msg_seq))
 		{
-/*FUDGE*/	/* temporary fudge: KLIPS doesn't yet generate replies for all messages */
-/*FUDGE*/	switch (pfkey_msg->sadb_msg_type)
-/*FUDGE*/	{
-/*FUDGE*/	case SADB_X_GRPSA:
-/*FUDGE*/	case SADB_X_ADDFLOW:
-/*FUDGE*/	case SADB_X_DELFLOW:
-/*FUDGE*/	    loglog(RC_LOG_SERIOUS
-/*FUDGE*/		, "ignoring: no response to our PF_KEY %s message for %s %s"
-/*FUDGE*/		, sparse_val_show(pfkey_type_names, pfkey_msg->sadb_msg_type)
-/*FUDGE*/		, description, text_said);
-/*FUDGE*/	    break;
-/*FUDGE*/	default:
 		    loglog(RC_LOG_SERIOUS
 			, "ERROR: no response to our PF_KEY %s message for %s %s"
 			, sparse_val_show(pfkey_type_names, pfkey_msg->sadb_msg_type)
 			, description, text_said);
 		    success = FALSE;
-/*FUDGE*/	}
 		}
 		else if (pfkey_msg->sadb_msg_type != bp->msg.sadb_msg_type)
 		{
@@ -1038,20 +1169,32 @@
     pfkey_register_proto(SADB_X_SATYPE_IPIP, "IPIP");
 }
 
+/* find an entry in the bare_shunt table.
+ * Trick: return a pointer to the entry; this allows the entry to be deleted.
+ */
+static struct bare_shunt **
+bare_shunt_ptr(ip_subnet *ours, ip_subnet *his)
+{
+    struct bare_shunt *p, **pp;
+
+    for (pp = &bare_shunts; (p = *pp) != NULL; pp = &p->next)
+       if (samesubnet(ours, &p->ours)
+       && samesubnet(his, &p->his))
+           return pp;
+    return NULL;
+}
+
 /* Setup an IPsec route entry. Code taken from addrt.c.
  * We are only dealing with outbound SAs.
- * op is one of the following KLIPS operators:
+ * op is one of the ERO_* operators.
  */
 
-#define ERO_REPLACE_FLAG   0x100	/* out of band */
-#define ERO_DELETE	SADB_X_DELFLOW
-#define ERO_ADD	SADB_X_ADDFLOW
-#define ERO_REPLACE	(SADB_X_ADDFLOW | ERO_REPLACE_FLAG)
-
 static bool
-do_eroute(struct state *st, unsigned op, const char *opname UNUSED)
+raw_eroute(const ip_address *this_host, const ip_subnet *this_client
+, const ip_address *that_host, const ip_subnet *that_client
+, ipsec_spi_t spi, unsigned int proto, unsigned int satype
+, unsigned int op, const char *opname UNUSED)
 {
-    struct connection *c = st->st_connection;
     struct sadb_ext *extensions[SADB_EXT_MAX + 1];
     ip_address
     	sflow_ska,
@@ -1059,6 +1202,151 @@
     	smask_ska,
     	dmask_ska;
     char text_said[SATOT_BUF];
+
+    set_text_said(text_said, that_host, spi, proto);
+
+    networkof(this_client, &sflow_ska);
+    maskof(this_client, &smask_ska);
+
+    networkof(that_client, &dflow_ska);
+    maskof(that_client, &dmask_ska);
+
+    DBG(DBG_CONTROL,
+       {
+           char mybuf[SUBNETTOT_BUF];
+           char peerbuf[SUBNETTOT_BUF];
+
+           subnettot(this_client, 0, mybuf, sizeof(mybuf));
+           subnettot(that_client, 0, peerbuf, sizeof(peerbuf));
+           DBG_log("%s eroute %s to %s via %s"
+               , opname, mybuf, peerbuf, text_said);
+       });
+
+    return pfkey_msg_start(op & ~ERO_REPLACE_FLAG, satype
+       , "pfkey_msg_hdr flow", text_said, extensions)
+
+    && (op == ERO_DELETE
+       || (pfkey_build(pfkey_sa_build(&extensions[SADB_EXT_SA]
+               , SADB_EXT_SA
+               , spi   /* in network order */
+               , 0, 0, 0, 0, op == ERO_REPLACE? SADB_X_SAFLAGS_REPLACEFLOW : 0)
+           , "pfkey_sa add flow", text_said, extensions)
+
+           && pfkeyext_address(SADB_EXT_ADDRESS_SRC, this_host
+               , "pfkey_addr_s add flow", text_said, extensions)
+
+           && pfkeyext_address(SADB_EXT_ADDRESS_DST, that_host
+               , "pfkey_addr_d add flow", text_said, extensions)))
+
+    && pfkeyext_address(SADB_X_EXT_ADDRESS_SRC_FLOW, &sflow_ska
+       , "pfkey_addr_sflow", text_said, extensions)
+
+    && pfkeyext_address(SADB_X_EXT_ADDRESS_DST_FLOW, &dflow_ska
+       , "pfkey_addr_dflow", text_said, extensions)
+
+    && pfkeyext_address(SADB_X_EXT_ADDRESS_SRC_MASK, &smask_ska
+       , "pfkey_addr_smask", text_said, extensions)
+
+    && pfkeyext_address(SADB_X_EXT_ADDRESS_DST_MASK, &dmask_ska
+       , "pfkey_addr_dmask", text_said, extensions)
+
+    && finish_pfkey_msg(extensions, "flow", text_said, NULL);
+}
+
+/* Replace (or delete) a shunt that is in the bare_shunts table.
+ * Issues the PF_KEY commands and updates the bare_shunts table.
+ */
+bool
+replace_bare_shunt(const ip_address *src, const ip_address *dst
+, ipsec_spi_t shunt_spi        /* in host order! */
+, bool repl, const char *opname)
+{
+    err_t ugh;
+    ip_subnet this_client, that_client;
+    const ip_address *null_host = aftoinfo(addrtypeof(src))->any;
+    unsigned int op = repl? ERO_REPLACE : ERO_DELETE;
+
+    passert(addrtypeof(src) == addrtypeof(dst));
+    ugh = rangetosubnet(src, src, &this_client);
+    passert(ugh == NULL);
+    ugh = rangetosubnet(dst, dst, &that_client);
+    passert(ugh == NULL);
+
+    if (raw_eroute(null_host, &this_client, null_host, &that_client
+    , htonl(shunt_spi), SA_INT, SADB_X_SATYPE_INT, op, opname))
+    {
+       struct bare_shunt **bs_pp = bare_shunt_ptr(&this_client, &that_client);
+       struct bare_shunt *bs = *bs_pp;
+
+       if (repl)
+       {
+           /* change over to new bare eroute */
+           bs->said.spi = htonl(shunt_spi);
+           bs->said.proto = SA_INT;
+           bs->said.dst = *null_host;
+           bs->count = 0;
+           bs->last_activity = now();
+       }
+       else
+       {
+           /* a delete bare eroute */
+           *bs_pp = bs->next;
+           pfree(bs);
+       }
+       return TRUE;
+    }
+    else
+    {
+       return FALSE;
+    }
+}
+
+static bool
+eroute_connection(struct connection *c
+, ipsec_spi_t spi, unsigned int proto, unsigned int satype
+, unsigned int op, const char *opname)
+{
+    return raw_eroute(&c->this.host_addr, &c->this.client
+       , &c->that.host_addr, EffectivePeerClient(c)
+       , spi, proto, satype, op, opname);
+}
+
+/* assign a bare hold to a connection */
+
+bool
+assign_hold(struct connection *c
+, const ip_address *src, const ip_address *dst)
+{
+    /* either the automatically installed HOLD eroute is broad enough
+     * or we try to add a broader one and delete the automatic one.
+     */
+    if (subnetishost(&c->this.client) && subnetishost(&c->that.client))
+    {
+       /* although HOLD is appropriately broad, it will no longer be bare
+        * so we must ditch it from the bare table.
+        */
+       struct bare_shunt **bs_pp = bare_shunt_ptr(&c->this.client
+           , &c->that.client);
+       struct bare_shunt *bs = *bs_pp;
+
+       *bs_pp = bs->next;
+       pfree(bs);
+       return TRUE;
+    }
+    else
+    {
+       /* we broaden by adding an HOLD eroute and deleting the old bare HOLD */       return eroute_connection(c, htonl(SPI_HOLD), SA_INT, SADB_X_SATYPE_INT
+               , ERO_ADD, "add broader HOLD")
+           && replace_bare_shunt(src, dst, SPI_HOLD, FALSE
+               , "delete for broader HOLD");
+    }
+}
+
+/* install or remove eroute for SA Group */
+static bool
+sag_eroute(struct state *st, unsigned op, const char *opname)
+{
+    struct connection *c = st->st_connection;
     unsigned int
     	inner_proto,
 	inner_satype;
